package dns

// Code generated by http://github.com/gojuno/minimock (3.0.6). DO NOT EDIT.

//go:generate minimock -i github.com/rekby/lets-proxy2/internal/dns.mDNSClient -o ./m_dns_client_mock_test.go

import (
	"sync"
	mm_atomic "sync/atomic"
	"time"
	mm_time "time"

	"github.com/gojuno/minimock/v3"
	mdns "github.com/miekg/dns"
)

// MDNSClientMock implements mDNSClient
type MDNSClientMock struct {
	t minimock.Tester

	funcExchange          func(msg *mdns.Msg, address string) (r *mdns.Msg, rtt time.Duration, err error)
	inspectFuncExchange   func(msg *mdns.Msg, address string)
	afterExchangeCounter  uint64
	beforeExchangeCounter uint64
	ExchangeMock          mMDNSClientMockExchange
}

// NewMDNSClientMock returns a mock for mDNSClient
func NewMDNSClientMock(t minimock.Tester) *MDNSClientMock {
	m := &MDNSClientMock{t: t}
	if controller, ok := t.(minimock.MockController); ok {
		controller.RegisterMocker(m)
	}

	m.ExchangeMock = mMDNSClientMockExchange{mock: m}
	m.ExchangeMock.callArgs = []*MDNSClientMockExchangeParams{}

	return m
}

type mMDNSClientMockExchange struct {
	mock               *MDNSClientMock
	defaultExpectation *MDNSClientMockExchangeExpectation
	expectations       []*MDNSClientMockExchangeExpectation

	callArgs []*MDNSClientMockExchangeParams
	mutex    sync.RWMutex
}

// MDNSClientMockExchangeExpectation specifies expectation struct of the mDNSClient.Exchange
type MDNSClientMockExchangeExpectation struct {
	mock    *MDNSClientMock
	params  *MDNSClientMockExchangeParams
	results *MDNSClientMockExchangeResults
	Counter uint64
}

// MDNSClientMockExchangeParams contains parameters of the mDNSClient.Exchange
type MDNSClientMockExchangeParams struct {
	msg     *mdns.Msg
	address string
}

// MDNSClientMockExchangeResults contains results of the mDNSClient.Exchange
type MDNSClientMockExchangeResults struct {
	r   *mdns.Msg
	rtt time.Duration
	err error
}

// Expect sets up expected params for mDNSClient.Exchange
func (mmExchange *mMDNSClientMockExchange) Expect(msg *mdns.Msg, address string) *mMDNSClientMockExchange {
	if mmExchange.mock.funcExchange != nil {
		mmExchange.mock.t.Fatalf("MDNSClientMock.Exchange mock is already set by Set")
	}

	if mmExchange.defaultExpectation == nil {
		mmExchange.defaultExpectation = &MDNSClientMockExchangeExpectation{}
	}

	mmExchange.defaultExpectation.params = &MDNSClientMockExchangeParams{msg, address}
	for _, e := range mmExchange.expectations {
		if minimock.Equal(e.params, mmExchange.defaultExpectation.params) {
			mmExchange.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmExchange.defaultExpectation.params)
		}
	}

	return mmExchange
}

// Inspect accepts an inspector function that has same arguments as the mDNSClient.Exchange
func (mmExchange *mMDNSClientMockExchange) Inspect(f func(msg *mdns.Msg, address string)) *mMDNSClientMockExchange {
	if mmExchange.mock.inspectFuncExchange != nil {
		mmExchange.mock.t.Fatalf("Inspect function is already set for MDNSClientMock.Exchange")
	}

	mmExchange.mock.inspectFuncExchange = f

	return mmExchange
}

// Return sets up results that will be returned by mDNSClient.Exchange
func (mmExchange *mMDNSClientMockExchange) Return(r *mdns.Msg, rtt time.Duration, err error) *MDNSClientMock {
	if mmExchange.mock.funcExchange != nil {
		mmExchange.mock.t.Fatalf("MDNSClientMock.Exchange mock is already set by Set")
	}

	if mmExchange.defaultExpectation == nil {
		mmExchange.defaultExpectation = &MDNSClientMockExchangeExpectation{mock: mmExchange.mock}
	}
	mmExchange.defaultExpectation.results = &MDNSClientMockExchangeResults{r, rtt, err}
	return mmExchange.mock
}

//Set uses given function f to mock the mDNSClient.Exchange method
func (mmExchange *mMDNSClientMockExchange) Set(f func(msg *mdns.Msg, address string) (r *mdns.Msg, rtt time.Duration, err error)) *MDNSClientMock {
	if mmExchange.defaultExpectation != nil {
		mmExchange.mock.t.Fatalf("Default expectation is already set for the mDNSClient.Exchange method")
	}

	if len(mmExchange.expectations) > 0 {
		mmExchange.mock.t.Fatalf("Some expectations are already set for the mDNSClient.Exchange method")
	}

	mmExchange.mock.funcExchange = f
	return mmExchange.mock
}

// When sets expectation for the mDNSClient.Exchange which will trigger the result defined by the following
// Then helper
func (mmExchange *mMDNSClientMockExchange) When(msg *mdns.Msg, address string) *MDNSClientMockExchangeExpectation {
	if mmExchange.mock.funcExchange != nil {
		mmExchange.mock.t.Fatalf("MDNSClientMock.Exchange mock is already set by Set")
	}

	expectation := &MDNSClientMockExchangeExpectation{
		mock:   mmExchange.mock,
		params: &MDNSClientMockExchangeParams{msg, address},
	}
	mmExchange.expectations = append(mmExchange.expectations, expectation)
	return expectation
}

// Then sets up mDNSClient.Exchange return parameters for the expectation previously defined by the When method
func (e *MDNSClientMockExchangeExpectation) Then(r *mdns.Msg, rtt time.Duration, err error) *MDNSClientMock {
	e.results = &MDNSClientMockExchangeResults{r, rtt, err}
	return e.mock
}

// Exchange implements mDNSClient
func (mmExchange *MDNSClientMock) Exchange(msg *mdns.Msg, address string) (r *mdns.Msg, rtt time.Duration, err error) {
	mm_atomic.AddUint64(&mmExchange.beforeExchangeCounter, 1)
	defer mm_atomic.AddUint64(&mmExchange.afterExchangeCounter, 1)

	if mmExchange.inspectFuncExchange != nil {
		mmExchange.inspectFuncExchange(msg, address)
	}

	mm_params := &MDNSClientMockExchangeParams{msg, address}

	// Record call args
	mmExchange.ExchangeMock.mutex.Lock()
	mmExchange.ExchangeMock.callArgs = append(mmExchange.ExchangeMock.callArgs, mm_params)
	mmExchange.ExchangeMock.mutex.Unlock()

	for _, e := range mmExchange.ExchangeMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.r, e.results.rtt, e.results.err
		}
	}

	if mmExchange.ExchangeMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmExchange.ExchangeMock.defaultExpectation.Counter, 1)
		mm_want := mmExchange.ExchangeMock.defaultExpectation.params
		mm_got := MDNSClientMockExchangeParams{msg, address}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmExchange.t.Errorf("MDNSClientMock.Exchange got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmExchange.ExchangeMock.defaultExpectation.results
		if mm_results == nil {
			mmExchange.t.Fatal("No results are set for the MDNSClientMock.Exchange")
		}
		return (*mm_results).r, (*mm_results).rtt, (*mm_results).err
	}
	if mmExchange.funcExchange != nil {
		return mmExchange.funcExchange(msg, address)
	}
	mmExchange.t.Fatalf("Unexpected call to MDNSClientMock.Exchange. %v %v", msg, address)
	return
}

// ExchangeAfterCounter returns a count of finished MDNSClientMock.Exchange invocations
func (mmExchange *MDNSClientMock) ExchangeAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmExchange.afterExchangeCounter)
}

// ExchangeBeforeCounter returns a count of MDNSClientMock.Exchange invocations
func (mmExchange *MDNSClientMock) ExchangeBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmExchange.beforeExchangeCounter)
}

// Calls returns a list of arguments used in each call to MDNSClientMock.Exchange.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmExchange *mMDNSClientMockExchange) Calls() []*MDNSClientMockExchangeParams {
	mmExchange.mutex.RLock()

	argCopy := make([]*MDNSClientMockExchangeParams, len(mmExchange.callArgs))
	copy(argCopy, mmExchange.callArgs)

	mmExchange.mutex.RUnlock()

	return argCopy
}

// MinimockExchangeDone returns true if the count of the Exchange invocations corresponds
// the number of defined expectations
func (m *MDNSClientMock) MinimockExchangeDone() bool {
	for _, e := range m.ExchangeMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.ExchangeMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterExchangeCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcExchange != nil && mm_atomic.LoadUint64(&m.afterExchangeCounter) < 1 {
		return false
	}
	return true
}

// MinimockExchangeInspect logs each unmet expectation
func (m *MDNSClientMock) MinimockExchangeInspect() {
	for _, e := range m.ExchangeMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to MDNSClientMock.Exchange with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.ExchangeMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterExchangeCounter) < 1 {
		if m.ExchangeMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to MDNSClientMock.Exchange")
		} else {
			m.t.Errorf("Expected call to MDNSClientMock.Exchange with params: %#v", *m.ExchangeMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcExchange != nil && mm_atomic.LoadUint64(&m.afterExchangeCounter) < 1 {
		m.t.Error("Expected call to MDNSClientMock.Exchange")
	}
}

// MinimockFinish checks that all mocked methods have been called the expected number of times
func (m *MDNSClientMock) MinimockFinish() {
	if !m.minimockDone() {
		m.MinimockExchangeInspect()
		m.t.FailNow()
	}
}

// MinimockWait waits for all mocked methods to be called the expected number of times
func (m *MDNSClientMock) MinimockWait(timeout mm_time.Duration) {
	timeoutCh := mm_time.After(timeout)
	for {
		if m.minimockDone() {
			return
		}
		select {
		case <-timeoutCh:
			m.MinimockFinish()
			return
		case <-mm_time.After(10 * mm_time.Millisecond):
		}
	}
}

func (m *MDNSClientMock) minimockDone() bool {
	done := true
	return done &&
		m.MinimockExchangeDone()
}
